<template>
  <v-form @submit.prevent="submit">
    <v-container>
      <v-row dense>
        <v-col cols="12">
          <v-text-field
            :label="$t('email')"
            hide-details
            outlined
            v-model="email"
            :disabled="confirmRequested"
          >
          </v-text-field>
        </v-col>

        <v-col cols="12" v-if="confirmRequested">
          <v-btn text color="primary" small @click="rollback"
            >Сменить email</v-btn
          >
        </v-col>

        <v-col cols="12">
          <v-btn
            v-if="!confirmRequested"
            block
            large
            color="primary"
            @click="complete"
            :loading="loading"
            >{{ $t('complete') }}</v-btn
          >
        </v-col>

        <template v-if="confirmRequested">
          <v-col cols="12">
            <v-text-field
              :label="$t('code')"
              outlined
              v-model="code"
              hide-details
            ></v-text-field>
          </v-col>

          <v-col cols="12">
            <v-btn block large color="primary" @click="confirm">{{
              $t('confirm')
            }}</v-btn>
          </v-col>

          <v-col cols="12">
            <p>
              Мы выслали вам код подтверждения на указанную почту для входа в
              сервис. Введите его и нажмите "продолжить"
            </p>
          </v-col>
        </template>
      </v-row>
    </v-container>
  </v-form>
</template>

<script lang="ts">
import Vue from 'vue';
import Component from 'vue-class-component';
import { ConfirmLoginForm } from '@/domain/form/confirm/ConfirmLoginForm';
import { EmailAuthRequestForm } from '@/domain/form/auth/request/EmailAuthRequestForm';
import { Prop } from 'vue-property-decorator';

@Component({})
export default class LoginForm extends Vue {
  @Prop({
    default: '',
    type: String,
    required: false
  })
  private readonly predefinedEmail!: string;

  private loading: boolean = false;

  private email: string = '';
  private code: string = '';
  private confirmRequested: boolean = false;

  private async mounted(): Promise<void> {
    if (this.predefinedEmail) {
      this.email = this.predefinedEmail;
      await this.complete();
    }
  }

  private async submit(): Promise<void> {
    if (this.confirmRequested) {
      await this.confirm();
    } else {
      await this.complete();
    }
  }

  private async confirm(): Promise<void> {
    await this.$store.dispatch(
      'auth/confirm',
      new ConfirmLoginForm(this.email, this.code)
    );
    await this.$router.push({
      name: 'Courses'
    });
  }

  private async complete(): Promise<void> {
    this.loading = true;
    try {
      await this.$store.dispatch(
        'auth/request',
        new EmailAuthRequestForm(this.email)
      );
      this.confirmRequested = true;
    } finally {
      this.loading = false;
    }
  }

  private async rollback(): Promise<void> {
    this.confirmRequested = false;
  }
}
</script>

<style scoped></style>

<i18n>
{
  "ru": {
    "email": "Email",
    "code": "Код",
    "confirm": "Подтвердить",
    "complete": "Продолжить"
  }
}
</i18n>
